<id>
Advanced template system
</id>

<version>
1.0
</version>

<mod info>
This mod lets you specify an individual template for almost every page/section in YaBB.
Install instructions:
1. In your /Variables directory create a new directory called: "templates" (without the quotes). 
2. Chmod this directory to 666 or 777 (same as the /Variables directory)
3. Place the config2.dat file in this directory and chmod it to 666 or 777
4. Place moreto.pl in your /Sources directory and chmod it to 755
4. Install this mod as usual

Manual:
In your admin-center the "Edit forum template" menu has been renamed to "Manage templates" and below that
a new menu item called "More template options" has been inserted. 
Manage templates:
This page allows you to edit your templates. You can have up to 20 templates.
Select a template from the drop-down box and click on "Load". Now you can edit this template and rename it.
When you first load an "empty" template, it will be replaced by the default template. The default template
is the one you used before installing this mod and is the first one in the drop-down list.
More template options:
On this page you can assign your templates to pages/sections in YaBB. Select the template from the drop-down
list and click on save.

NOTES:
Some colors in YaBB are NOT controlled by templates (for example the Search results)! 
Look at the "CSS Plus" mod by D2N for a workaround.

Version History:
0.5: First beta version
1.0: Final release. No bugs reported by beta-tester
</mod info>

<author>
cae
</author>

<homepage>
g-a-p@gmx.li
</homepage>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
sub ModifyTemplate {
	&is_admin;
	my( $fulltemplate, $line );
	fopen(FILE, "$boarddir/template.html");
	while( $line = <FILE> ) {
		$line =~ s~[\r\n]~~g;
		&FromHTML;
		$fulltemplate .= qq~$line\n~;
	}
	fclose(FILE);
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'216'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <BR><font size="1">$txt{'682'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
    <form action="$cgi;action=modtemp2" method="POST"><BR>
    <textarea rows=30 cols=95 wrap=virtual name="template" style="width:98%">$fulltemplate</textarea>
    <br><BR><input type=submit value="$txt{'10'}"></form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'216'}";
	&template;
	exit;
}
</search for>

<replace>
sub ModifyTemplate {
	&is_admin;
	my( $fulltemplate, $line, $maxte, $i, $tnotfound, @line );
	
	fopen(FILE, "$vardir/templates/config2.dat");
	@configs2 = <FILE>;
	fclose(FILE);
	$maxte=@configs2;
	$tnotfound = "";
	if ($FORM{'chooset'}) {	
	
	
		if (-e "$vardir/templates/template$FORM{'chooset'}.html" ) {
	
			fopen(FILE, "$vardir/templates/template$FORM{'chooset'}.html");
			while( $line = <FILE> ) {
				$line =~ tr/\r//d;
				$line =~ tr/\n//d;
				$line =~ s/&/&amp;/g;
				$line =~ s/</&lt;/g;
				$line =~ s/>/&gt;/g;
				$line =~ s/\|/\&#124;/g;
				$line =~ s/\%/&#37;/g;
				$line =~ s/"/&quot;/g;
				$fulltemplate .= qq~$line\n~;
			}
			fclose(FILE);
		} else 
		{
		$tnotfound=qq~<b>$mto{'8'}</b>~;
		
		fopen(FILE, "template.html");
		@line = <FILE>;
		fclose(FILE);
		
		fopen(FILE, ">$vardir/templates/template$FORM{'chooset'}.html", 1);
		print FILE @line;
		fclose(FILE);
		
		
		fopen(FILE, "template.html");
		while( $line = <FILE> ) {
			$line =~ tr/\r//d;
			$line =~ tr/\n//d;
			$line =~ s/&/&amp;/g;
			$line =~ s/</&lt;/g;
			$line =~ s/>/&gt;/g;
			$line =~ s/\|/\&#124;/g;
			$line =~ s/\%/&#37;/g;
			$line =~ s/"/&quot;/g;
			$fulltemplate .= qq~$line\n~;
		}
		fclose(FILE);
				
		
		}
	} else {
		fopen(FILE, "template.html");
		while( $line = <FILE> ) {
			$line =~ tr/\r//d;
			$line =~ tr/\n//d;
			$line =~ s/&/&amp;/g;
			$line =~ s/</&lt;/g;
			$line =~ s/>/&gt;/g;
			$line =~ s/\|/\&#124;/g;
			$line =~ s/\%/&#37;/g;
			$line =~ s/"/&quot;/g;
			$fulltemplate .= qq~$line\n~;
		}
		fclose(FILE);
	}
	
	
	$yytitle = "$txt{'216'}";
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'216'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <BR><font size=1>$txt{'682'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
    <form action="$cgi&action=modtemp" method="POST"><BR>


<b>$mto{'6'}: </b>&nbsp;<select name="chooset" size=1>    
~;

for( $i = 0; $i < $maxte; $i++ ) {
$selected="";
if ($FORM{'chooset'} eq $i) {$selected = " selected";}

$yymain .= qq~<option value="$i"$i$selected>$configs2[$i]\n~;

}

$yymain .= qq~
</select>&nbsp;
    <input type=submit name="loadt" value="$mto{'7'}"><br>$tnotfound<br></form>
    
    
    $mto{'10'}: <b>$configs2[$FORM{'chooset'}]</b>
    <form action="$cgi&action=modtemp2" method="POST">
    <textarea rows=30 cols=95 wrap=virtual name="template" style="width:98%">$fulltemplate</textarea>
    <p>$mto{'10'}: <b>$configs2[$FORM{'chooset'}]</b></p>
    
    <input type=hidden name="whicht" value="$FORM{'chooset'}">
    $mto{'9'}: <input type=text name="renamet" value="" size="20">
    
    <input type=submit value="$txt{'10'}"><br>
    </form></font></td>
  </tr>
</table>
~;
	&template;
	exit;
}
</replace>

<search for>
sub ModifyTemplate2 {
	&is_admin;
	$FORM{'template'} =~ tr/\r//d;
	$FORM{'template'} =~ s~\A\n~~;
	$FORM{'template'} =~ s~\n\Z~~;
	fopen(FILE, ">$boarddir/template.html");
	print FILE $FORM{'template'};
	fclose(FILE);
	$yySetLocation = qq~$cgi&action=admin~;
	&redirectexit;
}
</search for>

<replace>
sub ModifyTemplate2 {
	&is_admin;
	if ($FORM{'renamet'} && $FORM{'whicht'} eq "0") 
	{ &fatal_error($mto{'11'});}

	$FORM{'template'} =~ tr/\r//d;
	$FORM{'template'} =~ s~\A\n~~;
	$FORM{'template'} =~ s~\n\Z~~;
	if ($FORM{'whicht'} eq "0") {
		fopen(FILE, ">$boarddir/template.html");
		print FILE $FORM{'template'};
		fclose(FILE); 
		} 
 	if ($FORM{'whicht'} ne "0") {
		fopen(FILE, ">$vardir/templates/template$FORM{'whicht'}.html");
		print FILE $FORM{'template'};
		fclose(FILE); 
		}
	
	if ($FORM{'renamet'}) {
		fopen(FILE, "$vardir/templates/config2.dat");
		@configs2 = <FILE>;
		fclose(FILE);
	
		foreach $ii (@configs2) {
		
			if ($ii eq "$FORM{'renamet'}\n") {
				&fatal_error("$mto{'14'}");}
				}
	
		$configs2[$FORM{'whicht'}] = "$FORM{'renamet'}\n";

		fopen(FILE, ">$vardir/templates/config2.dat");
		print FILE @configs2;
		fclose(FILE); 
		}
	
	$yySetLocation = qq~$cgi&action=modtemp~;
	&redirectexit;
}
</replace>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        <a href="$cgi&action=modtemp">$txt{'216'}</a><br>
</search for>

<replace>
        <a href="$cgi&action=modtemp">$mto{'13'}</a><br>
        <a href="$cgi&action=moreto">$mto{'1'}</a><br>
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	fopen(TEMPLATE,"template.html") || die("$txt{'23'}: template.html");
	@yytemplate = <TEMPLATE>;
	fclose(TEMPLATE);
</search for>

<replace>
	####
	$templfile = 'template.html';
	
	if ($currentboard) {
		fopen(FILE, "$boardsdir/$currentboard.mto", 1);
		$sel = <FILE>;
		fclose(FILE);
		chomp($sel);
		$templfile = "$vardir/templates/template$sel.html";
		}
	
	fopen(FILE, "$vardir/templates/config.dat") ;
	@configs = <FILE>;
	fclose(FILE);
	for( $i = 0; $i < @configs; $i++ ) {
		chomp($configs[$i]);}

	if ($action eq 'register' || $action eq 'register2') {$templfile = "$vardir/templates/template$configs[0].html";}
	elsif (($action eq '' && $currentboard eq '') || $action  eq 'login2' || $action eq 'logout' ) {$templfile = "$vardir/templates/template$configs[1].html";}
	elsif ($action eq 'search' || $action eq 'search2') {$templfile = "$vardir/templates/template$configs[2].html";}
	elsif ($action eq 'profile' || $action eq 'profile2' || $action eq 'viewprofile') {$templfile = "$vardir/templates/template$configs[3].html";}
	elsif ($action eq 'shownotify' ) {$templfile = "$vardir/templates/template$configs[4].html";}
	elsif ($action eq 'login' ) {$templfile = "$vardir/templates/template$configs[5].html";}
	elsif ($action eq 'recent' ) {$templfile = "$vardir/templates/template$configs[6].html";}
	elsif ($action eq 'mlall' || $action eq 'mlletter' || $action eq 'mltop' ) {$templfile = "$vardir/templates/template$configs[7].html";}
	elsif ($action eq 'im' || $action eq 'imoutbox' || $action eq 'imsend2' || $action eq 'imsend' || $action eq 'imprefs') {$templfile = "$vardir/templates/template$configs[8].html";}
	
	if (!-e $templfile) {$templfile = "template.html";}
	
	
	fopen(TEMPLATE,"$templfile") || die("$txt{'23'}: $templfile");
	@yytemplate = <TEMPLATE>;
	fclose(TEMPLATE);
	####
</replace>

<edit file>
YaBB.pl
</edit file>

<search for>
		elsif ($action eq 'modifyboard') { require "$sourcedir/ManageBoards.pl"; &ModifyBoard; }
</search for>

<add after>
		###
		elsif ($action eq 'moreto') {require "$sourcedir/moreto.pl"; &Moreto; }
		elsif ($action eq 'moreto2') {require "$sourcedir/moreto.pl"; &Moreto2; }
		###
</add after>

<edit file>
english.lng
</edit file>

<search for>
1;
</search for>

<replace>
$mto{'1'} = "More template options";
$mto{'2'} = "For every page listed below you can select a template to be used on this page. To edit your templates, go to 'Manage templates'";
$mto{'3'} = "General pages";
$mto{'4'} = "Lets you specify which template to for for each page";
$mto{'5'} = "Boards";
$mto{'6'} = "Choose template to edit";
$mto{'7'} = "Load template";
$mto{'8'} = "Template didn't exist yet. Has been created from default template.";
$mto{'9'} = "Rename to";
$mto{'10'}= "Currently editing template";
$mto{'11'}= "You cannot rename the default template!";
$mto{'12'}= "Category";
$mto{'13'}= "Manage templates";
$mto{'14'}= "Name for template already exists!";

$mton{'1'} = "Register";
$mton{'2'} = "Board Index";
$mton{'3'} = "Search";
$mton{'4'} = "Profile";
$mton{'5'} = "Notifications";
$mton{'6'} = "Login";
$mton{'7'} = "Recent";
$mton{'8'} = "Memberlist";
$mton{'9'} = "Private Messages";

1;
</replace>